# 
#  Scratchpad MMU - Boot loader preparation
#  Copyright (C) Jack Whitham 2009
#  http://www.jwhitham.org.uk/c/smmu.html
# 
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation
#  (version 2.1 of the License only).
#  
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#  
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
# 

# Prepare a file for download to boot program

TARGET = 0x90000000
MODIFIED = "already prepared"

import sys

def Main():
    if ( len(sys.argv) != 2 ):
        print 'Usage: %s <bin file>' % sys.argv[ 0 ]
        return 1

    fname = sys.argv[ 1 ] 
    code = file(fname, "rb").read()

    if ( code.strip().endswith(MODIFIED) ):
        print 'Already prepared.'
        return 0

    code += MODIFIED
    while (( len(code) % 4 ) != 0 ):
        code += " "

    size = len(code)
    out = file(fname, "wb")
    out.write(chr((size >> 24) & 0xff))
    out.write(chr((size >> 16) & 0xff))
    out.write(chr((size >> 8) & 0xff))
    out.write(chr((size >> 0) & 0xff))
    out.write(chr((TARGET >> 24) & 0xff))
    out.write(chr((TARGET >> 16) & 0xff))
    out.write(chr((TARGET >> 8) & 0xff))
    out.write(chr((TARGET >> 0) & 0xff))
    out.write(code)
    out.close()
    return 0

if __name__ == "__main__":
    sys.exit(Main())



